package com.javaVillage.org;

import de.imatics.forms.connector.DataConnector;
import de.imatics.util.naming.HierarchicName;
import org.apache.log4j.Logger;

import java.util.HashMap;
import java.util.Map;

/**
 * Example implementation fr a connector.
 * This connector logs every value from the form via log4j
 */
public class LoggingConnector implements DataConnector {
	private static final Logger logger = Logger.getLogger(LoggingConnector.class);

	private Map submittedValues;

	/**
	 * Methode is called while loading form for every form component
	 * @param cName full name of the component
	 * @return
	 */
	public Object getValue(HierarchicName cName) {
		return null;
	}

	/**
	 * Methode is called while loading form for every form repeat component
	 * to retrieve the initial number of rows in repeat.
	 * @param rName full name of the repeat component
	 * @return
	 */
	public int getRepeatCount(HierarchicName rName) {
		return 0;
	}

	/**
	 * Is called on start of submit process
	 */
	public void startSubmission() {
		logger.info("submission startet");
		submittedValues = new HashMap();
	}

	public void setValue(HierarchicName cName, Object value) {
		logger.info("got value for " + cName.toString() + ": " + value);
		submittedValues.put(cName.toString(), value);

	}

	public void setRepeatCount(HierarchicName rName, int rowCount) {
		logger.info("got repeat count for " + rName.toString() + ": " + rowCount);
		// here you can initialize a sub connector for instance
	}

	/**
	 * Is called on end of submit process.
	 * @return
	 */
	public Object submitValues() {
		// Write your data to your backend. This may be a database or anything else.
		return submittedValues;
	}
}
