var AjaxPopup = Class.create({
	initialize : function(trigger, url, properties) {
		this.trigger = $(trigger);
		this.url = url;
		this.cache = true;
		this.reload = false;
		this.reloadCount = 0;
		this.loadMessage = "Loading...";
		this.triggerEvent = "click";
		this.popupOptions = {};
		if (properties) {
			this.cache = typeof properties.cache == 'undefined'
					? true : properties.cache;

			this.popupContainer = typeof properties.popupContainer == 'undefined' ? null : $(properties.popupContainer);
			if (this.popupContainer) {
				this.popupContainerId = this.popupContainer.id;

				// Pop-up-DIV ans Ende des Bodys verschieben
				Element.remove(this.popupContainer);
				document.body.appendChild(this.popupContainer);
			}
			this.contentContainer = (typeof properties.contentContainer) == 'undefined' ? undefined : $(properties.contentContainer);

			if (typeof properties.reload != 'undefined') {
				this.reload = properties.reload;
			}
			if (typeof properties.loadMessage != 'undefined') {
				this.loadMessage = properties.loadMessage;
			}
			if (typeof properties.loadStyleClass != 'undefined') {
				this.loadStyleClass = properties.loadStyleClass;
			}
			if (typeof properties.closeHandle != 'undefined') {
				this.popupOptions.closebox = properties.closeHandle;
			}
			if (typeof properties.dragHandle != 'undefined') {
				this.popupOptions.draghandle = properties.dragHandle;
			}
			if (typeof properties.resizeHandle != 'undefined') {
				this.resizeHandle = properties.resizeHandle;
			}
			if (typeof properties.trigger != 'undefined') {
				this.triggerEvent = properties.trigger;
				this.popupOptions.trigger = properties.trigger;
			}
		}

		if (!this.popupContainerId) {
			this.popupContainerId = this.trigger.id + '_' + (new Date()).getTime();
		}

		this.contentLoaded = false;
		
		var thisPopup = this;
		this._initPopupWrapper = function(event) {
			Event.stopObserving(thisPopup.trigger, thisPopup.triggerEvent, thisPopup._initPopupWrapper);
			thisPopup._initPopup(thisPopup, event);
		};
		Event.observe(this.trigger, thisPopup.triggerEvent, this._initPopupWrapper);
	},

	_initPopup: function(initializer, event) {
		if (!initializer.popupContainer) {
			initializer.popupContainer = initializer._createPopupContainer();
		}
		initializer._loadContent(true, event);
	},

	_loadContent: function(show, event) {
		var thisInstance = this;
		var container = this.contentContainer ? this.contentContainer : this.popupContainer;
		
		new Ajax.Updater(container, this.url,
		{
			onComplete: function() {
				thisInstance.contentLoaded = true;
				if (show) {
					thisInstance._show(thisInstance, event);
				}
			},
			onFailure: function(transport) {
				alert(transport.statusText);
			}/*,
			onSuccess: function() {
				alert("aktualisiert");
			}*/
		});
	},

	_reloadContent: function() {
		if (this.reloadCount++ > 0) {
			var container = this.contentContainer ? this.contentContainer : this.popupContainer;
			container.update('');
			this._loadContent(false);
		}
	},

	_createPopupContainer: function() {
		var div = document.createElement('div');
		div.setAttribute('id', this.popupContainerId);
		div.setAttribute('class', 'popup');
		div.setAttribute('style', 'display:none;');
		document.body.appendChild(div);

		var textNode = document.createTextNode(this.loadMessage);
		div.appendChild(textNode);

		return div;
	},

	_show: function(initializer, event) {
		if (!initializer.popup) {
			var options = {/*'modal':true,'position':'center',*/'hidden':false};
			if (initializer.reload) {
				options['beforeShow'] = function() {initializer._reloadContent(initializer)};
			}
			for (var option in initializer.popupOptions) {
				options[option] = initializer.popupOptions[option];
			}
			initializer.popup = new Popup(initializer.popupContainer, initializer.trigger, options);


			// TODO Grennderung des Dialogs
			/*if (typeof initializer.resizeHandle != 'undefined') {
				try {
					var resizeHandles = Selector.findChildElements(initializer.popupContainer, $A(["." + initializer.resizeHandle]));
					if (resizeHandles.length > 0) {
					}
				}
				catch (ex) {
					alert(ex);
				}
			}*/
			initializer.popup.show(event);
		}
	},

	hide: function() {
		if (this.popup) {
			this.popup.hide();
		}
	}
});

function submitValue(value, componentId) {
	var parentWindow = window;//window.parent || window.opener;
	parentWindow.setElementValue(componentId, value);
	parentWindow.doOnChange(parentWindow.document.getElementById(componentId));
	fe_closeModalPopup();
}

function cancelDialog() {
	fe_closeModalPopup();
}

function fe_closeModalPopup() {
	Popup.closeLatestModalPopup();
}
function fe_showModalDialog(trigger, containerId, contentContainerId, dialogUrl, loadMessage) {
	var options = {'closeHandle':'fe_mdialog_close_handle','dragHandle':'fe_mdialog_drag_handle',
			'resizeHandle':'fe_mdialog_resize_handle',
			'overlayId':'fe_mdialog_overlay',
			'loadMessage':loadMessage, 'loadStyleClass':'fe_mdialog_loading',
			'popupContainer':containerId, 'contentContainer': contentContainerId,
			'reload':true};
	new AjaxPopup(trigger, dialogUrl, options);
}