
function highlightStars(star) {
	updateStarClasses(star, "_hover_active", "_hover_passive");
}

function updateStarClasses(star, activeSuffix, passiveSuffix) {
	var container = star.parentNode;
	var children = Element.childElements(container);
	var active = true;
	var isFirst = true;
	children.each(function(item) {
		var itemActive = active;
		var namePrefix = "fe_rating_star";
		if (isFirst) {
			isFirst = false;
			if (Element.hasClassName(item, "fe_rating_zero_active") || Element.hasClassName(item, "fe_rating_zero_passive"))  {
				// das erst Feld ist der 0-Wert
				namePrefix = "fe_rating_zero";
				if (item != star) {
					// es wurde nicht der 0-Wert gewhlt - diesen also deselktieren
					itemActive = false;
				}
			}
		}
		if (itemActive) {
			Element.addClassName(item, namePrefix + activeSuffix);
			Element.removeClassName(item, namePrefix + passiveSuffix);
			if (item == star) {
				// ab dem nchsten Stern alle passiv
				active = false;
			}
		}
		else {
			Element.addClassName(item, namePrefix + passiveSuffix);
			Element.removeClassName(item, namePrefix + activeSuffix);
		}
	});
}

function resetStars(container) {
	var children = Element.childElements(container);
	var isFirst = true;
	children.each(function(item) {
		if (isFirst) {
			// das erste KANN der 0-Wert sein - zustzlich auch diese Klassen entfernen
			isFirst = false;
			Element.removeClassName(item, "fe_rating_zero_hover_active");
			Element.removeClassName(item, "fe_rating_zero_hover_passive");
		}
		Element.removeClassName(item, "fe_rating_star_hover_active");
		Element.removeClassName(item, "fe_rating_star_hover_passive");
	});
}

function setRating(star, value) {
	updateStarClasses(star, "_active", "_passive");
	sendValue(star, value);
}