var TabContainer = Class.create({
	initialize : function(container, options) {
		this.container = $(container);
		this.options = {
			// Platz fr default-Optionen
			// TODO css-Klassennamen ber Optionen konfigurierbar
		};
		Object.extend(this.options, options || { });
		this.registerTabButtons();
		this.container.addClassName('imx_tab_container');
	},

	registerTabButtons: function() {
		var tabButtonsContainer = $(document.createElement('div'));
		tabButtonsContainer.addClassName('imx_tabs');

		this.tabs = new Array();

		// Tab-Buttons in einen Wrapper verschieben und registrieren
//		var tabPanes = this.container.select('> .imx_tab_pane');  // funktioniert leider nicht
		var tabPanes = this.container.childElements().grep(new Selector('.imx_tab_pane'));

		var tabPaneWrapper = $(document.createElement('div')); // Wrapper fr die Reiterinhalte
		tabPaneWrapper.addClassName('imx_tab_panes');

		var activeTabDefined = false;
		var lastTab = null;
		for (var i = 0; i < tabPanes.length; i++) {
			var tabPane = tabPanes[i];
//			var tabButtons = tabPane.select('> .imx_tab'); // funktioniert leider nicht
			var tabButtons = tabPane.childElements().grep(new Selector('.imx_tab'));
			if (tabButtons && tabButtons.length > 0) {
				var tabButton = $(tabButtons[0]);
				if (tabButton.hasClassName('imx_active_tab') && !activeTabDefined) {
					activeTabDefined = true;
				}
				else {
					tabPane.hide();
				}
				var tabContainer = this;
				tabButton.remove();
				tabButtonsContainer.insert(tabButton);

				// Reiterinhalt in DIV mit Klasse "imx_tab_inner" einbetten
				var tabButtonInner = $(document.createElement('div'));
				tabButtonInner.addClassName('imx_tab_inner');
				var tabButtonChildNodes = tabButton.childElements();
				if (tabButtonChildNodes && tabButtonChildNodes.length > 0) {
					for (var j = tabButtonChildNodes.length - 1; j >= 0; j--) {
						var childNode = $(tabButtonChildNodes[j]);
						childNode.remove();
						tabButtonInner.insert(childNode);
					}
				}
				tabButton.insert(tabButtonInner);

				Event.observe(tabButton, "click", function() {
					tabContainer.toggleTabs(this);
				});
				this.tabs.push({button: tabButton, pane: tabPane});

				tabPane.remove();
				if (lastTab == null) {
					tabPaneWrapper.insert(tabPane);
				}
				else {
					tabPaneWrapper.insertBefore(tabPane, lastTab);
				}
				lastTab = tabPane;
			}
		}
		this.container.insert(tabPaneWrapper);

		if (!activeTabDefined && this.tabs.length > 0) {
			var tab = this.tabs[0];
			tab.pane.show();
			tab.button.addClassName('imx_active_tab');
		}
		this.container.insert({top: tabButtonsContainer});
	},

	toggleTabs: function(button) {
		for (var i = 0; i < this.tabs.length; i++) {
			var tab = this.tabs[i];
			var tabButton = tab.button;
			var tabPane = tab.pane;
			if (tabButton == button) {
				tabButton.addClassName('imx_active_tab');
				tabPane.show();
				this.onActivateTab(this.container.id, tabPane.id);
			}
			else {
				tabButton.removeClassName('imx_active_tab');
				tabPane.hide();
			}
		}
	},

	onActivateTab: function(containerId, tabId) {
		var f = this.options['onActivateTab'];
		if (f) {
			f(containerId, tabId);
		}
//		new Ajax.Request('/SessionData/setActiveTab',
//			{
//				parameters: {container: containerId, tab: tabId}
//			});
	}
});